<script setup>
import { onMounted, reactive } from "vue";
import { useRouter, useRoute } from "vue-router";
import { storeToRefs } from "pinia";
import { useMovieStore } from "../stores/movies";

const router = useRouter();
const route = useRoute();
const movieStore = useMovieStore();
const { getMovie } = storeToRefs(movieStore);
const { fetchMovieById, addMovie, updateMovie, deleteMovie } = movieStore;

const movieData = reactive({
  id: 0,
  title: "",
  director: "",
  summary: "",
  genres: [],
});

onMounted(() => {
  console.log(movieData.title);
  if (route.params.id) {
    fetchMovieById(route.params.id)
      .then((res) => {
        movieData.id = res[0].id;
        movieData.title = res[0].title;
        movieData.director = res[0].director;
        movieData.summary = res[0].summary;
        movieData.genres = res[0].genres;
      })
      .catch((err) => {
        console.error("Error: ", err);
      });
  }
});

function cancelOrDelete() {
  if (route.params.id) {
    return "Delete";
  }

  return "Cancel";
}

function onCancelOrDelete() {
  if (route.params.id) {
    deleteMovie(movieData)
      .then(() => {
        router.push("/");
      })
      .catch((err) => {
        console.log("Error: ", err);
      });
  } else {
    router.push("/");
  }
}

function toggleGenre(genre) {
  if (movieData.genres.includes(genre)) {
    movieData.genres = movieData.genres.filter((g) => g !== genre);
  } else {
    movieData.genres.push(genre);
  }
}

function onSubmit() {
  if (route.params.id) {
    updateMovie(movieData)
      .then((res) => {
        if (res) router.push("/");
      })
      .catch((err) => {
        console.log("Error: ", err);
      });
  } else {
    addMovie(movieData)
      .then((res) => {
        router.push("/");
      })
      .catch((err) => {
        console.log("Error: ", err);
      });
  }
}
</script>

<template>
  <div class="page-wrapper">
    <q-form class="form-container" @submit="onSubmit">
      <header>
        <div class="button-box">
          <q-btn
            :label="cancelOrDelete()"
            @click="onCancelOrDelete"
            style="width: 82px"
          />
          <q-btn
            label="Save"
            type="submit"
            style="width: 82px; margin-left: 16px"
            :disabled="movieData.genres.length === 0"
          />
        </div>
      </header>
      <main style="padding: 16px 0">
        <div class="input-box">
          <div class="title">Title&nbsp;</div>
          <q-input outlined v-model="movieData.title" required />
        </div>
        <div class="input-box">
          <div class="title">Director&nbsp;</div>
          <q-input outlined v-model="movieData.director" required />
        </div>
        <div class="input-box">
          <div class="title">Summary&nbsp;</div>
          <q-input
            outlined
            type="textarea"
            maxlength="100"
            v-model="movieData.summary"
          />
        </div>
        <div class="chips-box">
          <q-chip
            class="chips-item"
            :style="{
              background: movieData.genres.includes('Action')
                ? 'antiquewhite'
                : 'none',
            }"
            clickable
            @click="toggleGenre('Action')"
            >Action</q-chip
          >
          <q-chip
            class="chips-item"
            :style="{
              background: movieData.genres.includes('Animation')
                ? 'antiquewhite'
                : 'none',
            }"
            clickable
            @click="toggleGenre('Animation')"
            >Animation</q-chip
          >
          <q-chip
            class="chips-item"
            :style="{
              background: movieData.genres.includes('Drama')
                ? 'antiquewhite'
                : 'none',
            }"
            clickable
            @click="toggleGenre('Drama')"
            >Drama</q-chip
          >
          <q-chip
            class="chips-item"
            :style="{
              background: movieData.genres.includes('Sci-Fi')
                ? 'antiquewhite'
                : 'none',
            }"
            clickable
            @click="toggleGenre('Sci-Fi')"
            >Sci-Fi</q-chip
          >
        </div>
      </main>
    </q-form>
  </div>
</template>

<style lang="scss" scoped>
.form-container {
  header {
    padding: 16px 0;
    border-bottom: 1px solid;
    min-width: 375px;

    .button-box {
      text-align: right;
      padding-right: 16px;
    }
  }

  main {
    padding: 16px;
    width: 80%;
    max-width: 1023px;
    min-width: 375px;
    margin: 0 auto;

    .input-box {
      position: relative;
      padding-top: 20px;

      .title {
        font-size: 16px;
        position: absolute;
        top: 8px;
        left: 12px;
        background: #fff;
        z-index: 1;
      }
    }

    .chips-box {
      padding-top: 20px;

      .chips-item {
        background: none;
        border: 1px solid;
        cursor: pointer;
      }
    }
  }
}
</style>

<style>
.page-wrapper
  .form-container
  main
  .input-box
  .q-field__control.relative-position.row.no-wrap {
  border-radius: 12px;
}
</style>
